<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle" />
    <div
      class="userList"
      v-if="isAdmin"
    >
      <el-row>
        <el-col>
          <dl>
            <dt><b>Administrator</b>:- Handle all the user, resource and request management.</dt>
            <dd>
              <dl>
                <dt><b>User Management</b>:- Administrator can handle the role, add/delete/modify the user. Also able to configure Edge Gallry url for guest page. Administrator can give access to login app developer.</dt>
              </dl>
            </dd>
            <dd>
              <dl>
                <dt><b>Resource Management</b>:- Administrator can add/delete labs, resources and environments</dt>
              </dl>
            </dd>
            <dd>
              <dl>
                <dt><b>Request Management</b>:- Administrator can approve/reject environment requests raised by app developer.</dt>
              </dl>
            </dd>
          </dl>
        </el-col>
      </el-row>
      <!-- <div style="text-align:center">
        <img
          src="../assets/images/admin_hierarchy.png"
          class="graph_img"
        >
      </div> -->
      <h2 style="text-align: center">
        Functional Flow
      </h2>
      <div class="wrapper">
        <network
          class="network"
          ref="network"
          :nodes="network.nodes"
          :edges="network.edges"
          :options="network.options"
        />
        <network
          class="network"
          ref="network1"
          :nodes="network1.nodes"
          :edges="network1.edges"
          :options="network1.options"
        />
      </div>
    </div>
    <div
      class="userList"
      v-else
    >
      <el-row>
        <el-col>
          <dl>
            <dt><b>App Developer</b>:- Raise request from environment resource and get access of that.</dt>
            <dd>
              <dl>
                <dt><b>My Application</b>:- Raise request for to get environment resource which will be approve or reject by administrator.</dt>
              </dl>
            </dd>
            <dd>
              <dl>
                <dt><b>My Environments</b>:- All approved environment resource list will be show here, which can be released by the app developer.</dt>
              </dl>
            </dd>
          </dl>
        </el-col>
      </el-row>
      <!-- <div style="text-align:center">
        <img
          src="../assets/images/app_hierarchy.png"
          class="graph_img"
        >
      </div> -->
    </div>
    <Footer />
  </div>
</template>
<script>
import Footer from '../components/Footer.vue'
import { Network } from 'vue-vis-network'

let defNodes = [
  { id: 0, label: 'App Developer', shape: 'circularImage', image: 'dev.png', imagePadding: 0, size: 30 },
  { id: 1, label: 'Requested', shape: 'circularImage', image: 'req.png', imagePadding: 0, size: 30 },
  { id: 2, label: 'Administrator', shape: 'circularImage', image: 'admin.png', imagePadding: 4, size: 30 },
  { id: 3, label: 'Cancelled', shape: 'circularImage', image: 'cancel.png', imagePadding: 4, size: 30 },
  { id: 4, label: 'Rejected', shape: 'circularImage', image: 'reject.jpg', imagePadding: 0, size: 30 },
  { id: 5, label: 'Approved', shape: 'circularImage', image: 'approved.png', imagePadding: 4, size: 30 },
  { id: 6, label: 'End', shape: 'circularImage', image: 'end.jpg', imagePadding: 0, size: 30 },
  { id: 7, label: 'Environment Allocated', shape: 'circularImage', image: 'allot.png', imagePadding: 4, size: 30 }
  // { id: 8, label: 'Environment Release' },
  // { id: 9, label: 'Environment Delete' },
]

let defEdges = [
  { id: 0, from: 0, to: 1 },
  { id: 2, from: 1, to: 2 },
  { id: 1, from: 1, to: 3 },
  { id: 3, from: 2, to: 4 },
  { id: 4, from: 4, to: 6 },
  { id: 5, from: 2, to: 5 },
  { id: 7, from: 5, to: 7 },
  { id: 8, from: 3, to: 6 }
  // { id: 9, from: 7, to: 0 }
  // { id: 9, from: 7, to: 5 },
  // { id: 10, from: 0, to: 7 },
  // { id: 11, from: 0, to: 2 },
  // { id: 12, from: 9, to: 4 },
  // { id: 13, from: 0, to: 2 },
  // { id: 14, from: 9, to: 8 },
  // { id: 15, from: 8, to: 5 },
  // { id: 16, from: 9, to: 3 }
]
let defNodes1 = [
  { id: 0, label: 'App Dev', shape: 'circularImage', image: 'dev.png', imagePadding: 0, size: 30 },
  { id: 1, label: 'Env Allocated', shape: 'circularImage', image: 'allot.png', imagePadding: 4, size: 30 },
  { id: 2, label: 'Released', shape: 'circularImage', image: 'release.png', imagePadding: 0, size: 30 },
  { id: 3, label: 'Expired', shape: 'circularImage', image: 'expired.png', imagePadding: 0, size: 30 },
  { id: 4, label: 'End', shape: 'circularImage', image: 'end.jpg', imagePadding: 0, size: 30 }
]
let defEdges1 = [
  { id: 0, from: 0, to: 1 },
  { id: 1, from: 1, to: 2 },
  { id: 2, from: 1, to: 3 },
  { id: 3, from: 2, to: 4 },
  { id: 4, from: 3, to: 4 }
]
export default {
  name: 'Help',
  data: () => ({
    isAdmin: true,
    networkEvents: '',
    network: {
      nodes: defNodes.slice(0),
      edges: defEdges.slice(0),
      options: {
        nodes: {
          shape: 'dot',
          size: 30,
          color: {
            border: 'grey',

            highlight: {
              border: 'black',
              background: 'white'
            },
            hover: {
              border: 'orange',
              background: 'grey'
            }
          },
          font: { color: 'black', size: 18 },
          shapeProperties: {
            useBorderWithImage: true
          }
        },
        edges: {
          arrows: 'to'
        },
        layout: {
          randomSeed: 1
        }
      }
    },
    network1: {
      nodes: defNodes1.slice(0),
      edges: defEdges1.slice(0),
      options: {
        nodes: {
          shape: 'dot',
          size: 24,
          color: {
            border: 'grey',

            highlight: {
              border: 'black',
              background: 'white'
            },
            hover: {
              border: 'orange',
              background: 'grey'
            }
          },
          font: { color: 'black', size: 18 },
          shapeProperties: {
            useBorderWithImage: true
          }
        },
        edges: {
          arrows: 'to'
        },
        layout: {
          randomSeed: 1
        }
      }
    }
  }),
  components: {
    Footer,
    Network
  },
  beforeMount () {
  },
  computed: {
  },
  methods: {
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
.wrapper {
  padding: 20px 50px;
  text-align: center;
  display: flex;
  justify-content: space-between;
}
.events {
  text-align: left;
  height: 70px;
}

.network {
  height: 600px;
  width: 49%;
  border: 1px solid #ccc;
  margin: 5px 0;
}
</style>
